<?php
/**
 *  
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/forms/EditOpponentdetailForm.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbOpponent.class.php";

class BBSB_EditOpponentdetailAction extends BBSB_AbstractEditAction
{
	/**
	 * ǡ(1ʬ)
	 * @var unknown_type
	 */
	var $mTeamList				= null;

    /**
     * ե।󥹥󥹤κ
     * @see modules/[modulename]/class/BBSB_AbstractEditGamedetailAction#_setupActionForm()
     */
    function _setupActionForm()
	{
		$this->mActionForm =& new BBSB_EditOpponentdetailForm();
		$this->mActionForm->prepare();
	}

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		if( xoops_getrequest('tid') ){
			// tidȤ(ϻ)
			$tid = xoops_getrequest('tid');

			// tidɳդǡ
			$dbOp = new BBSB_DbOpponent();
			$dbOp->setData( 'TeamID', $tid );
			$this->mTeamList = $dbOp->getListbyCond( 'bb_opponent', _BBSB_FALSE_IS_ALL_COL, _BBSB_LIMIT_1 );

			// ǡեǤ˥å
			$this->mActionForm->mFormProperties['tid']->mValue			= $this->mTeamList[0]['TeamID'];		// TeamID
			$this->mActionForm->mFormProperties['teamname']->mValue		= $this->mTeamList[0]['TeamName'];		// ֥̾
			$this->mActionForm->mFormProperties['baseplace']->mValue	= $this->mTeamList[0]['BasePlace'];		// ֵ
			$this->mActionForm->mFormProperties['url']->mValue			= $this->mTeamList[0]['Url'];			// URL
			$this->mActionForm->mFormProperties['fullname']->mValue		= $this->mTeamList[0]['FullName'];		// ɽԻ̾
			$this->mActionForm->mFormProperties['phoneno']->mValue		= $this->mTeamList[0]['PhoneNo'];		// á
			$this->mActionForm->mFormProperties['mphoneno']->mValue		= $this->mTeamList[0]['MPhoneNo'];		// ַá
			$this->mActionForm->mFormProperties['memail']->mValue		= $this->mTeamList[0]['MEmail'];		// ַӥ᡼
			$this->mActionForm->mFormProperties['pcemail']->mValue		= $this->mTeamList[0]['PCEmail'];		// PC᡼
			$this->mActionForm->mFormProperties['comments']->mValue		= $this->mTeamList[0]['Comments'];		// ֥ȡ
			$this->mActionForm->mFormProperties['lastgamedate']->mValue	= date("Y-m-d",strtotime($this->mTeamList[0]['LastGameDate']));	// ֺǿ
		}

		return BBSB_FRAME_VIEW_INPUT;
	}

	/**
	 * ǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// 󥻥
		if( !xoops_getrequest('entry') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		$this->mActionForm->load($this->mObject);	// DBͤɬפ硢ǥǡɤ롩
		$this->mActionForm->fetch();				// ꥯȥեफͤμ
		$this->mActionForm->validate();				// ͭͤ

		// 顼ϥեɽ
		if($this->mActionForm->hasError()) {
			return BBSB_FRAME_VIEW_INPUT;
		}

		// ʹߡ顼åOKν
		// ==============================================================================

		// ơ֥Ͽ(bb_opponent)
		$dbOp =& new BBSB_DbOpponent();		// ǡѤDB󥹥
		$dbOp->setData( 'TeamName',		$this->mActionForm->mFormProperties['teamname']->mValue );
		$dbOp->setData( 'BasePlace',	$this->mActionForm->mFormProperties['baseplace']->mValue );
		$dbOp->setData( 'Url',			$this->mActionForm->mFormProperties['url']->mValue );
		$dbOp->setData( 'FullName',		$this->mActionForm->mFormProperties['fullname']->mValue );
		$dbOp->setData( 'PhoneNo',		$this->mActionForm->mFormProperties['phoneno']->mValue );
		$dbOp->setData( 'MPhoneNo',		$this->mActionForm->mFormProperties['mphoneno']->mValue );
		$dbOp->setData( 'MEmail',		$this->mActionForm->mFormProperties['memail']->mValue );
		$dbOp->setData( 'PCEmail',		$this->mActionForm->mFormProperties['pcemail']->mValue );
		$dbOp->setData( 'Comments',		$this->mActionForm->mFormProperties['comments']->mValue );
		$lgd = $this->mActionForm->mFormProperties['lastgamedate']->mValue;
		if( !$lgd ){		// դ̵nullˤƤ(ʤ0000äƤޤ)
			$lgd = null;
		}
		$dbOp->setData( 'LastGameDate',	$lgd );

		// TeamIDȤUPDATE(¸ǡԽ)ʤINSERT()
		if( $this->mActionForm->mFormProperties['tid']->mValue ){
			// ¸ǡԽUPDATE
			$keyarray = array( 'TeamID'=>$this->mActionForm->mFormProperties['tid']->mValue );
			$result = $dbOp->update( 'bb_opponent', $keyarray );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
			$tid = $this->mActionForm->mFormProperties['tid']->mValue;
		} else {
			// INSERT
			$result = $dbOp->insert( 'bb_opponent' );
			if( $result===false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}

			// INSERT줿TeamID롣
			$tid = $dbOp->mDb->getInsertId();
			if( !$tid ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		}

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * եѥӥ塼
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewInput(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("bbsb_editopponentdetail.html");
		$render->setAttribute("actionForm", $this->mActionForm);
		$render->setAttribute("xoops_module_header",	_BBSB_OP_CSSFILE .
														_BBSB_OP_CALENDAR_SYSTEM_CSS .
														_BBSB_OP_CALENDAR_JS .
														_BBSB_OP_CALENDAR_LANG_JS .
														_BBSB_OP_CALENDAR_SETUP_JS );

	}

	/**
	 *  Ͽν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewOpponentlist" );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν 
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewOpponentlist");
	}

}
?>
