<?php
/**
 * 饦ɾܺɽ
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGround.class.php";

class BBSB_ViewGrounddetailAction extends BBSB_AbstractEditAction
{
	/**
	 * 饦ɥǡ(1ʬ)
	 * @var unknown_type
	 */
	var $mGrList				= null;

	/**
	 * å
	 * @var unknown_type
	 */
	var $mDelMsg				= null;

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ¤Τ桼ʳɽԲ
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			$controller->executeForward(XOOPS_URL . '/');
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		// gidɬ
		if( !xoops_getrequest('gid') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$gid = xoops_getrequest('gid');

		// delϺ⡼()
		if( xoops_getrequest('del') ){
			$adminmode = null;
			if( is_object($controller->mRoot->mContext->mXoopsUser) ){
				$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
			}
			if( !$adminmode ){
				$controller->executeForward(XOOPS_URL . '/');
			}
			$this->mDelMsg = _MD_BBSB_INFO_DELCONFIRM;
		}

		// gidɳդ饦ɥǡ
		$dbGr = new BBSB_DbGround();
		$dbGr->setData( 'GroundID', $gid );
		$this->mGrList = $dbGr->getListbyCond( 'bb_ground', _BBSB_FALSE_IS_ALL_COL, _BBSB_LIMIT_1 );

		return BBSB_FRAME_VIEW_INDEX;
	}

	/**
	 * ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
		// delɬ
		if( !xoops_getrequest('del') ){
			$controller->executeForward(XOOPS_URL . '/');
		}
		$gid = xoops_getrequest('del');

		// delϺ⡼()
		$adminmode = null;
		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		if( !$adminmode ){
			return BBSB_FRAME_VIEW_ERROR;
		}

		// 󥻥
		if( !xoops_getrequest('delbutton') ){
			return BBSB_FRAME_VIEW_CANCEL;
		}

		// 饦ɥơ֥
		$dbGr = new BBSB_DbGround();
		$dbGr->setData( 'GroundID',	$gid );
		$ret = $dbGr->delete('bb_ground');

		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * 饦ɥǡɽؿ
	 * @param $controller
	 * @param $xoopsUser
	 * @param $render
	 * @return unknown_type
	 */
	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("bbsb_viewgrounddetail.html");
		$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);

		// 饦ɥǡեǡ˥å
		$render->setAttribute("grlist",			$this->mGrList);
		// Υå
		$render->setAttribute("delmsg",			$this->mDelMsg );

	}

	/**
	 * ΤȤ饦ɰ̤
	 */
	function executeViewSuccess(&$controller, &$xoopsUser, &$render)
	{
		$del	= xoops_getrequest('del');
		if( $del ){
			$del = "&del=" . $del;
		}
		$controller->executeForward("./index.php?action=ViewGroundlist" . $del );
	}

	/**
	 * Ͽ顼ν(DBι˼)
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * 󥻥ξν 饦ɰ
	 */
	function executeViewCancel(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeForward("./index.php?action=ViewGroundlist");
	}

}
?>
