<?php

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_ROOT_PATH . "/core/XCube_PageNavigator.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGame.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameEntrant.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGameBatter.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbGamePitcher.class.php";

/**
 * ݥ饹
 * @author tks
 *
 */
class BBSB_AbstractEditAction
{
	var $mObject = null;
	var $mGroundObject = null;
	/**
	 *
	 * @var unknown_type
	 */
	var $mGroundObjectHandler = null;
	var $mActionForm = null;	// ե।󥹥󥹡_setupActionForm()Ǻ
	var $mConfig	= null;		// ե

	/**
	 * @access protected
	 */
	function _setupActionForm()
	{
	}

	/**
	 * @access protected
	 */
	function _setupObject()
	{
	}

	/**
	 * ¹ν
	 * @param $controller
	 * @param $xoopsUser
	 * @param $moduleConfig
	 * @return unknown_type
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		$this->mConfig = $moduleConfig;

		$this->_setupActionForm();	// եϵ§
		$this->_setupObject();		// ֥ȤΥåȥå
	}

	function &_getPageNavi()
	{
		$navi =& new XCube_PageNavigator($this->_getBaseUrl(), XCUBE_PAGENAVI_START);
		return $navi;
	}

	/**
	 * ǡοϿorϿ¹
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function execute( &$controller, &$xoopsUser )
	{
	}

	/**
	 * ʤWHERE
	 * ̤ĿӲ̤ǡʤ߻˻ȤWHERE
	 * bb_gameơ֥̾'G'ȤSQLȤळȡ
	 * @return unknown_type
	 */
	function createWhereStrForSearch()
	{
		$wherestr = "";
		$wherearray = array('G.Nendo'			=> 'nendo',
							'MONTH(EventDate)'	=> 'month',
							'G.LeagueID'		=> 'leagueid',
							'G.TournamentID'	=> 'tournamentid',
							'G.GameOrderID'		=> 'gameorderid',
							'G.GroundID'		=> 'groundid' );
		foreach( $wherearray as $key => $value ){
			if( xoops_getrequest($value) ){
				if( $wherestr ){
					$wherestr .= " AND ";
				}
				$wherestr .= $key . "='" . xoops_getrequest($value) . "'";
			}
		}
		// opponentid = -1 ΤȤϥ쥯ȥܥå̤֤ʤΤwhereˤϴޤޤʤ
		if( xoops_getrequest('opponentid') != null && xoops_getrequest('opponentid') != '-1' ){
			if( $wherestr ){
				$wherestr .= " AND ";
			}
			// opponentid = 0 ΤȤϼˤ
			if( xoops_getrequest('opponentid') == 0 ){
				$wherestr .= " (FirstTeamID='0' AND LastTeamID='0') ";
			} else {
				$wherestr .= " (FirstTeamID='" . xoops_getrequest('opponentid') . "' OR LastTeamID='" . xoops_getrequest('opponentid') . "') ";
			}
		}
		if( $wherestr ){
			$wherestr = " WHERE " . $wherestr;
		}
		return $wherestr;
	}

	/**
	 * üԥơ֥(bb_gameentrant)˥ǡϿ
	 * @param $gid					GameID
	 * @param $lB[$r]['key'][$c]	Хåӥꥹ
	 *  $r :Сι 'UserID' ʤɤǤ˻
	 *  $c 1󤫤Υ˥襹 'ScoreMarkID','Direction','RBI'γƥ˥󥰤
	 * @return unknown_type
	 */
	function insEntrantData( $gid, &$lB ){
		$dbGameEntrant =& new BBSB_DbGameEntrant();		// üԥơ֥DB󥹥
		// äΥ쥳ɤ
		$dbGameEntrant->unsetData();
		$dbGameEntrant->setData( 'GameID', $gid );
		$ret = $dbGameEntrant->delete( 'bb_gameentrant' );
		// Ͽ
		foreach( $lB as $rkey => $Bdat ){
			$dbGameEntrant->setData( 'GameID',			$gid );
			$dbGameEntrant->setData( 'UserID',			$Bdat['UserID'] );
			$dbGameEntrant->setData( 'PlayOrder',		$Bdat['PlayOrder'] );
			$dbGameEntrant->setData( 'ChangeCnt',		$Bdat['ChangeCnt'] );
			$dbGameEntrant->setData( 'Position1',		$Bdat['Position1'] );
			$dbGameEntrant->setData( 'Position2',		$Bdat['Position2'] );
			$dbGameEntrant->setData( 'StolenBaseSuc',	$Bdat['StolenBaseSuc'] );
			$dbGameEntrant->setData( 'StolenBaseFail',	$Bdat['StolenBaseFail'] );
			$dbGameEntrant->setData( 'RunsCnt',			$Bdat['RunsCnt'] );
			$dbGameEntrant->setData( 'ErrorsCnt',		$Bdat['ErrorsCnt'] );
			$dbGameEntrant->setData( 'WinningRun',		$Bdat['WinningRun'] );
			$rbisum = 0;
			foreach( $Bdat['RBI'] as $key => $Rdat ){		// η׻
				if( $Rdat ){ $rbisum += $Rdat; }
			}
			$dbGameEntrant->setData( 'RBI',				$rbisum );
			$ret = $dbGameEntrant->insert( 'bb_gameentrant' );
			if( $ret === false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * Хåơ֥Ͽ(bb_gamebatter)
	 * @param $gid					GameID
	 * @param $Inlist				˥ͥꥹ0_BBSB_OP_GAME_DISPINNINGS 
	 * @param $lB[$r]['key'][$c]	Хåӥꥹ
	 *  $r :С 'UserID' Ǥ˻
	 *  $c  'ScoreMarkID','Direction','RBI'γƥ˥󥰤Ǥ
	 * @return unknown_type
	 */
	function insBatterData( $gid, &$Inlist, &$lB ){
		$dbGB =& new BBSB_DbGameBatter();		// Хåơ֥DB󥹥
		// äΥ쥳ɤ
		$dbGB->unsetData();
		$dbGB->setData( 'GameID', $gid );
		$ret = $dbGB->delete( 'bb_gamebatter' );
		// Ͽ
		$inning			= 1;	// ˥󥰿
		$batterno		= 1;	// Хåǽ(˥)
		$pcnt			= 0;	// ǽ總߰
		$nextinningpcnt	= 0;
		for( $icnt = 0 ; $icnt < _BBSB_OP_GAME_DISPINNINGS ; $icnt++ ){
			if( $Inlist[$icnt] == "" ){break;}
			if( $icnt > 0 && ($Inlist[$icnt-1] != $Inlist[$icnt]) ){
			  	$inning++;
			  	$batterno = 1;
			}
			$pcnt = $nextinningpcnt;	// ˥󥰤ƬХåǽ
			$nullsig = null;
			for( $i = 0 ; $i < count($lB) ; $i++ ){
				if( $pcnt == count($lB) ){	// ǽ礬Ǹޤ褿ƬǼԤ
					$pcnt = 0;
				}
				if( !$lB[$pcnt]['ScoreMarkID'][$icnt] ){		// ̵ޤ0ʤ鼡ΥХå
					$pcnt++;
					continue;
				}
				$dbGB->setData( 'GameID',		$gid );
				$dbGB->setData( 'Innings',		$inning );
				$dbGB->setData( 'BatterNo',		$batterno );
				$dbGB->setData( 'UserID',		$lB[$pcnt]['UserID'] );
				$dbGB->setData( 'ScoreMarkID',	$lB[$pcnt]['ScoreMarkID'][$icnt] );
				if( $lB[$pcnt]['Direction'][$icnt] ){
					$dbGB->setData( 'Direction',$lB[$pcnt]['Direction'][$icnt] );
				} else {
					$dbGB->setData( 'Direction',$nullsig );
				}
				if( $lB[$pcnt]['RBI'][$icnt] ){
					$dbGB->setData( 'RBI',		$lB[$pcnt]['RBI'][$icnt] );
				} else {
					$dbGB->setData( 'RBI',		$nullsig );
				}
				$ret = $dbGB->insert( 'bb_gamebatter' );
				if( $ret === false ){
					$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
					return BBSB_FRAME_VIEW_INPUT;
				}
				$batterno++;
				$pcnt++;
				$nextinningpcnt = $pcnt;
				if( $nextinningpcnt == count($lB) ){ $nextinningpcnt = 0; }
			}
		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * ԥå㡼ǡϿ(ơ֥롧bb_gamepitcher)
	 * @param $gid				GameID
	 * @param $lP[$r]['key']	ԥå㡼ӥꥹ
	 *  $r :С 'UserID' ʤɤǤ˻
	 * @return unknown_type
	 */
	function insPitcherData( $gid, &$lP ){
		// ԥå㡼ơ֥Ͽ(bb_gamepitcer)
		$dbGP =& new BBSB_DbGamePitcher();			// ԥå㡼ơ֥DB󥹥
		// äΥ쥳ɤ
		$dbGP->unsetData();
		$dbGP->setData( 'GameID', $gid );
		$ret = $dbGP->delete( 'bb_gamepitcher' );
		// Ͽ
		foreach( $lP as $key => $Pdat ){
			$dbGP->setData( 'GameID',		$gid );
			$dbGP->setData( 'ChangeCnt',	$key );	// Ľ(0)
			$dbGP->setData( 'UserID',		$Pdat['UserID'] );
			$dbGP->setData( 'Innings',		$Pdat['Innings'] );
			$dbGP->setData( 'OutCnt',		$Pdat['OutCnt'] );
			$dbGP->setData( 'EarnedRuns',	$Pdat['EarnedRuns'] );
			$dbGP->setData( 'Runs',			$Pdat['Runs'] );
			$dbGP->setData( 'KCnt',			$Pdat['KCnt'] );
			$dbGP->setData( 'BCnt',			$Pdat['BCnt'] );
			$dbGP->setData( 'DBCnt',		$Pdat['DBCnt'] );
			$dbGP->setData( 'HCnt',			$Pdat['HCnt'] );
			$dbGP->setData( 'HRCnt',		$Pdat['HRCnt'] );
			$dbGP->setData( 'NumOfPitch',	$Pdat['NumOfPitch'] );
			$dbGP->setData( 'Win',			$Pdat['Win'] );
			$dbGP->setData( 'Lose',			$Pdat['Lose'] );
			$dbGP->setData( 'Save',			$Pdat['Save'] );
			$dbGP->setData( 'Hold',			$Pdat['Hold'] );
			$ret = $dbGP->insert( 'bb_gamepitcher' );
			if( $ret === false ){
				$this->mActionForm->addErrorMessage(_MD_BBSB_ERROR_DATABASEUPDATE);	// DB
				return BBSB_FRAME_VIEW_INPUT;
			}
		}
		return BBSB_FRAME_VIEW_SUCCESS;
	}

	/**
	 * Ϥ줿СǡǷǡղä
	 * @param $gid		ID
	 * @param $Inlist	O)˥󥰥ǡ(ǷǡѤΥ˥󥰥إåͤ򥻥åȤ)
	 * @param $member[$r]	(O)üԥǡScoreMarkIDDirectionRBI˥ˤ줾쥻åȤ롣
	 * 	$r		üԹ
	 *  $key	UserIDɬס
	 * @param $viewmode ɽΤߤξ(Խ⡼ɤǤϤʤ)trueˤ롣
	 *                  trueξϡ˥󤬶ξ;פϤʤ
	 *                  (ꥤ˥󥰿ʤϵꥤ˥󥰿ޤǽϤ)
	 * @return unknown_type
	 */
	function getBatterScore( $gid, &$Inlist, &$member, $viewmode=false ){
		// gidɳդǷǡ
		$batList = array();
		$dbBa = new BBSB_DbGameBatter();
		$dbBa->setData('GameID', xoops_getrequest('gid') );
		$dbBa->setOrderBy('Innings');
		$dbBa->setOrderBy('BatterNo');
		$batList = $dbBa->getListbyCond('bb_gamebatter');

		// ǷǡեϤ˥å
		$rcnt		= 0;		// (å)
		$ccnt		= 0;		// (˥)
		$startrow	= 0;		// ˥󥰤γϹ԰
		$batterCnt	= 0;		// ˥󥰤ΥХå
		$matchFlg	= false;	// ǷǡȻüԥǡΥޥå󥰥ե饰
		foreach( $batList as $key => &$bdat ){		// Ƿ⥹ǡ롼
			if( $batterCnt > $bdat['BatterNo'] ){	// ХåNo1ͤä饤˥󥰤ʤȤߤʤ
				if( $rcnt != $startrow ){
					$ccnt++;						// ˥󥫥
				}
				$startrow = $rcnt;					// Ϲ԰¸
				$batterCnt = $bdat['BatterNo'];		// Хå󥿥ꥻå
			}
			for( $icnt = 0 ; $icnt < count($member) ; $icnt++ ){ 	// üԥ롼
				if( $member[$rcnt]['UserID'] == $bdat['UserID'] ){	// üԥǡǷǡפ
					$Inlist[$ccnt] = $bdat['Innings'];// ˥¸
					// Ƿǡå
					$member[$rcnt]['ScoreMarkID'][$ccnt]	= $bdat['ScoreMarkID'];
					$member[$rcnt]['Direction'][$ccnt]		= $bdat['Direction'];
					$member[$rcnt]['RBI'][$ccnt]			= $bdat['RBI'];
					$batterCnt++;
					$matchFlg = true;
				}
				$rcnt++;
				if( $rcnt == count($member) ){	// ԤǸޤǿʤ硢Ƭ
					$rcnt = 0;
				}
				if( $rcnt == $startrow ){		// 1ФƹԤ硢ؿʤ
					$ccnt++;
				}
				if( $matchFlg ){				// ޥå鼡Ƿǡ
					$matchFlg = false;
					break;
				}
			}
		}

		// ǷӤΥ˥󥰥إåӤäƤʤȤϡưǥ˥ͤ򥻥åȤƤ
		if( $Inlist ){
			$lastInningVal = $Inlist[count($Inlist)-1];
		} else {
			$lastInningVal = 0;
		}
		$maxcol = _BBSB_OP_GAME_DISPINNINGS;
		if( $viewmode ){
			$maxcol = _BBSB_OP_GAME_INNINGS;
		}
		for( $ccnt = count($Inlist) ; $ccnt < $maxcol ; $ccnt++ ){
			if( $ccnt < _BBSB_OP_GAME_INNINGS ){
				$Inlist[$ccnt]	= ++$lastInningVal;
			} else {
				$Inlist[$ccnt]	= "";
			}
		}
		// Խ⡼ɤǡɽꥤ˥󥰿¿Υ˥󥰥ǡäƤϡǡ˴롣
		if( !$viewmode && (count($Inlist) > $maxcol) ){
			$countmaxnum = count($Inlist);
			for( $ccnt = $maxcol ; $ccnt < $countmaxnum ; $ccnt++ ){
				unset($Inlist[$ccnt]);
			}
		}
	}

	/**
	 * 硧ʸѴ
	 * @param $pos	֤ɽ(19)
	 * @return 		б
	 */
	function getPositionStr( $pos ){
		// ʸѴ
		if( $pos === null ){ return ""; }
		$dirary = array(	1=>	_MD_BBSB_LANG_PITCHER,	// 
							2=>	_MD_BBSB_LANG_CATCHER,	// 
							3=>	_MD_BBSB_LANG_FIRST,	// 
							4=>	_MD_BBSB_LANG_SECOND,	// 
							5=>	_MD_BBSB_LANG_THIRD,	// 
							6=>	_MD_BBSB_LANG_SHORT,	// ͷ
							7=>	_MD_BBSB_LANG_LEFT ,	// 
							8=>	_MD_BBSB_LANG_CENTER,	// 
							9=>	_MD_BBSB_LANG_RIGHT);	// 
		return $dirary[$pos];
	}

	/**
	 * ưͽꡧ٥ȼʸѴ
	 * @param $evkindnum	٥ȼ(0 or 1 or 2 or 3)
	 * @return 				б륤٥ȼʸ
	 */
	function getEventKindStr( $evkindnum ){
		$ekarray = array( 	0=>"",
							1=> _MD_BBSB_LANG_GAME,		// 
							2=> _MD_BBSB_LANG_PRACTICE,	// 
							3=> _MD_BBSB_LANG_SETC		// ¾
		);
		return $ekarray[$evkindnum];
	}

	/**
	 * ʸκ
	 * 	yyyy-mm-dd() h:mm ʸ
	 *   hm̵դΤߡmmdd̵ǯΤߡ
	 * @param $year
	 * @param $month
	 * @param $day
	 * @param $hour
	 * @param $minute
	 * @param $mail		᡼Ѥ˻Ѥtrueˤ(Ⱦѥڡ򥨥פʤ)
	 * @return unknown_type
	 */
	function getDateStr( $year, $month, $day, $hour, $minute, $mail=false ){
		$datestr = "";
		$weekary = array(	0=>_MD_BBSB_LANG_SUN,
							1=>_MD_BBSB_LANG_MON,
							2=>_MD_BBSB_LANG_TUE,
							3=>_MD_BBSB_LANG_WED,
							4=>_MD_BBSB_LANG_THU,
							5=>_MD_BBSB_LANG_FRI,
							6=>_MD_BBSB_LANG_SAT
							);
		if( $month ){
			$datestr = $year . "-" . $month;
			if( $day ){
				$datestr .= "-" . $day;
				$weeknum=date("w", mktime(0,0,0,$month,$day,$year));
				$datestr .= "(" . $weekary[$weeknum] . ")";
				if( $hour!==null ){
					if( $mail ){
						$datestr .= " ";
					} else {
						$datestr .= "&nbsp;";
					}
					$datestr .= $hour . ":";
					if( $minute!==null ){
						$datestr .= sprintf( "%02d", $minute );
					} else {
						$datestr .= "--";
					}
				}
			}
		} else {
			$datestr = $year;
		}
		return $datestr;
	}

	/**
	 * ʸꤷĹǥåȤ"..."Ĥ
	 * @param $list
	 * @param $col
	 * @param $num
	 * @return unknown_type
	 */
	function truncatestr( &$list, $col, $num ){
		foreach( $list as &$dat ){
			if( mb_strlen($dat[$col]) > $num ){
				$dat[$col] = mb_substr( $dat[$col], 0, $num) . "...";
			}
		}
		return $list;
	}

}
?>
