<?php
/**
 * 塼
 */

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/AbstractEditAction.class.php";
require_once XOOPS_MODULE_PATH . "/" . _BBSB_DIRNAME . "/class/DbSchedule.class.php";

/***
 * @internal
 * @public
 */
class BBSB_ViewSchedulelistAction extends BBSB_AbstractEditAction
{
	/**
	 * ǯ٥쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mYearList			= array();

	/**
	 * /ȡʥȥ쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mTournamentList	= array();

	/**
	 * 饦ɥ쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mGroundList		= array();

	/**
	 * ꥻ쥯ȥܥåǡ
	 * @var unknown_type
	 */
	var $mOpponentList		= array();

	/**
	 * 塼ǡ
	 * @var unknown_type
	 */
	var $mScheList			= array();

	/**
	 * 쥳ɺå
	 * @var unknown_type
	 */
	var $mDelMsg			= null;

	/**
	 * ¹ν
	 */
	function prepare(&$controller, &$xoopsUser, $moduleConfig)
	{
		parent::prepare(&$controller, &$xoopsUser, $moduleConfig);
		// ưͽ굡ǽȤʤϽλ
		if( !_BBSB_OP_DISPSCHE && !is_object($root->mContext->mXoopsUser) ){
			$controller->executeForward("./index.php");
		}
	}

	/**
	 * ǥեɽɽܼ
	 * @param $controller
	 * @param $xoopsUser
	 * @return unknown_type
	 */
	function getDefaultView(&$controller, &$xoopsUser)
	{
		// ⡼ɻ
		if( xoops_getrequest('del') ){
			$this->mDelMsg = _MD_BBSB_INFO_DELOK;	// MSG
		}

		$dbSch = new BBSB_DbSchedule();

		// WHERE
		$wherestr = $this->createScheWhereStrForSearch();
		// 塼ꥹȼ
		$this->mScheList = $dbSch->getScheduleList( $wherestr );

		// ǡβù
		if( $this->mScheList ){
			foreach( $this->mScheList as $key => &$dat ){
				// ٥ȼ
				$dat['EventKind'] = $this->getEventKindStr( $dat['EventKind'] );
				// ʸ
				$dat['EventDate'] = $this->getDateStr( $dat['EventYear'], $dat['EventMonth'], $dat['EventDay'], $dat['EventHour'], $dat['EventMinute']);
				// դ̤Υ٥ȤɤĴ٤롣(Υ٥Ȥ϶Ĵɽ뤿)
				$dat['Comming'] = false;
				$edate = sprintf("%d%02d%02d", $dat['EventYear'], $dat['EventMonth'], $dat['EventDay'] );
				if( strcmp($edate, date("Ymd")) >= 0 ){
					$dat['Comming'] = true;
				}
			}
		}

		$this->mYearList		= $dbSch->getSelectYearList();			// ǯꥹȼ(쥳ɤ¸ߤǯ٤Τ߼ǯ٥ꥹȤȤ)
		$this->mTournamentList	= $dbSch->getSelectSTournamentList();	// /ȡʥȥꥹȼ(쥳ɤ¸ߤȡʥȤΤ߼ǯ٥ꥹȤȤ)
		$this->mTournamentList	= $this->truncatestr( $this->mTournamentList, 'TournamentName', 20 );
		$this->mGroundList		= $dbSch->getSelectSGroundList();		// 饦ɥꥹȼ(쥳ɤ¸ߤ륰饦ɤΤ߼ǯ٥ꥹȤȤ)
		$this->mGroundList		= $this->truncatestr( $this->mGroundList, 'GroundName', 20 );
		$this->mOpponentList	= $dbSch->getSelectSOpponentList();		// ꥹȼ(쥳ɤ¸ߤΤ߼ǯ٥ꥹȤȤ)
		$this->mOpponentList	= $this->truncatestr( $this->mOpponentList, 'TeamName', 20 );
		// νͤ-1
		if( xoops_getrequest('opponentid') === null ){
			$_GET['opponentid']='-1';
		}

		return BBSB_FRAME_VIEW_INDEX;
	}

	function executeViewIndex(&$controller, &$xoopsUser, &$render)
	{
		$render->setTemplateName("bbsb_viewschedulelist.html");
		$render->setAttribute('xoops_module_header', _BBSB_OP_CSSFILE);

		if( is_object($controller->mRoot->mContext->mXoopsUser) ){
			$adminmode = $controller->mRoot->mContext->mXoopsUser->isAdmin($controller->mRoot->mContext->mModule->mXoopsModule->get('mid'));
		}
		$render->setAttribute('adminmode',		$adminmode);			// ¤Τ桼ɤ
		$render->setAttribute('delmsg',			$this->mDelMsg);		// å

		// 쥯ȥܥå
		$render->setAttribute("years",			$this->mYearList);		// ǯ쥯ȥܥå
		$montharray = array("1","2","3","4","5","6","7","8","9","10","11","12");
		$render->setAttribute("months",			$montharray);			// Υ쥯ȥܥå
		$render->setAttribute("tournamentlist",	$this->mTournamentList);// ȡʥ
		$render->setAttribute("groundlist",		$this->mGroundList);	// 饦
		$render->setAttribute("opponentlist",	$this->mOpponentList);	// 

		$render->setAttribute('scheList',	$this->mScheList );			// 塼ǡ
	}

	/**
	 * 顼ν
	 */
	function executeViewError(&$controller, &$xoopsUser, &$render)
	{
		$controller->executeRedirect("index.php", 1, _MD_BBSB_ERROR_DATABASEUPDATE);
	}

	/**
	 * ʤWHERE(塼)
	 * bb_scheduleơ֥̾'S'ȤSQLȤळȡ
	 * @return unknown_type
	 */
	function createScheWhereStrForSearch()
	{
		$wherestr = "";
		// ǯ
		$year = xoops_getrequest('year');
		if( $year ){
			if( $year == date("Y") ){	// ǯƱǯꤵƤϡǯʹߤξʬͽޤ
				$cmpchar = ">=";
			} else {
				$cmpchar = "=";
			}
			$wherestr .= "EventYear" . $cmpchar . "'" . $year . "'";
		}
		// ȡʥID饦ID
		$wherearray = array('EventMonth'		=> 'month',
							'S.TournamentID'	=> 'tournamentid',
							'S.GroundID'		=> 'groundid' );
		foreach( $wherearray as $key => $value ){
			if( xoops_getrequest($value) ){
				if( $wherestr ){
					$wherestr .= " AND ";
				}
				$wherestr .= $key . "='" . xoops_getrequest($value) . "'";
			}
		}
		// 
		if( xoops_getrequest('opponentid') != null  && xoops_getrequest('opponentid') != '-1' ){			// opponentid = -1 ΤȤ̤֤ʤΤWehreȤʤ
			if( $wherestr ){
				$wherestr .= " AND ";
			}
			$teamid = xoops_getrequest('opponentid');
			$wherestr .= " (Opponent1='" . $teamid . "' "
						. " OR Opponent2='" . $teamid . "' "
						. " OR Opponent3='" . $teamid . "') ";
		}
		if( $wherestr ){
			$wherestr = " WHERE " . $wherestr;
		}
		return $wherestr;
	}

}
?>