<?php
if (!defined('XOOPS_ROOT_PATH')) exit();

require_once(XOOPS_ROOT_PATH . '/class/module.textsanitizer.php');
/**
 * ǡ١ݥ饹
 */
class BBSB_AbstractDatabase {

	/**
     * ǡ١֥
	 * @var XoopsDatabase
	 */
	var $mDb = null;

    /**
     * DB/Ｐѥǡ
     * @var unknown_type
     */
	protected $mData = array();

    /**
     * ORDER BYѥǡ
     * @var unknown_type
     */
	protected $mOrder = array();

	// 󥹥ȥ饯
    function BBSB_AbstractDatabase() {
        /* XCLDB쥯饹 */
        $root =& XCube_Root::getSingleton();
        $this->mDb =& $root->mController->mDB;
    }

    /**
     * ȯ
     * @param String $sqlstr SQLʸ
     * @param String $force  queryFѤ
     * @return query ȯԷ
     */
    function execute( $sqlstr, $force = null ) {
    	if( $force ){
        	$result = $this->mDb->queryF($sqlstr);
    	} else {
    		$result = $this->mDb->query($sqlstr);
    	}
        return $result;
    }

    /**
     * DBüʸ
     * @param string $text ƥ
     */
    function addSlashes( $text ){
    	return addslashes( $text );
    	//return $text;
    }

    /**
     * ơ֥Υ쥳ɿ򥫥Ȥ롣
     * @param String $table ơ֥̾
     * @param array  $exceptkey ()оݤ˴ޤʤ
     * @return boolean
     */
    function CountNum( $table, $exceptkey=false ) {
    	// WHERE
    	$wherestr	= "";
    	if( $this->mData ){
	    	foreach( $this->mData as $key => $value ){
	    		if( $wherestr ){
	    			$wherestr .= " AND ";
	    		}
	    		$wherestr .= $key . "='" . $this->addSlashes($value) . "'";
	    	}
    	}
    	$sqlstr = " SELECT COUNT(*) FROM " . $this->mDb->prefix($table);
		if( $exceptkey ){
			$exstr = "";
			foreach( $exceptkey as $key => $value ){
				if( $exstr ){
					$exstr .= " AND ";
				}
				$exstr .= $key . "='" . $this->addSlashes($value) . "'";
			}
			if( $exstr ){
				$wherestr .= " AND NOT ( " . $exstr . " ) ";
			}
		}
		if( $wherestr ){
			$sqlstr .= " WHERE " . $wherestr;
		}
		$rc = $this->execute($sqlstr);
		if( $rc ){
			$dat = $this->mDb->fetchArray($rc);
			return $dat['COUNT(*)'];
		} else {
			return 0;
		}
    }

    /**
     * ǡ١ꥹȷǥǡ
     * @param String $sqlstr
     * @return Array
     */
    function getList( $sqlstr ) {
        $result = $this->execute($sqlstr);
        $list = array();
        while ($row = $this->mDb->fetchArray($result)) {
            $list[] = $row;
        }
        return $list;
    }

    /**
     * դǥǡ
     *  $mData ˥̾ͤåȤƤϡξǸ
     *  $mOrder ˥̾åȤƤϡν֤Ǹ
     * @param $table ơ֥̾
     * @param $col   ŪSELECTǼ󤬤̾(޶ڤ)
     * 					ꤵƤʤ*
     * @param $limit 쥳ɿ(LIMIT)
     * @return ǡ
     */
	function getListbyCond( $table, $col = false, $limit = false ) {
		if( $col ){
			$sqlstr = " SELECT " . $col . " FROM " . $this->mDb->prefix($table);
		} else {
			$sqlstr = " SELECT * FROM " . $this->mDb->prefix($table);
		}
		// WHERE
		$wherestr = "";
		if( $this->mData ){
			$wherestr = "";
			foreach( $this->mData as $key => $value ){
				if( $wherestr ){
					$wherestr .= " AND ";
				}
				$wherestr .= $key . "='" . $this->addSlashes($value) . "' ";
			}
			$wherestr = " WHERE " . $wherestr;
		}
		$sqlstr .= $wherestr;
		// ORDER BY
		$order = "";
		if( $this->mOrder ){
			$order = "";
			foreach( $this->mOrder as $value ){
				if( $order ){
					$order .= ", ";
				}
				$order .= $value['Col'] . " " . $value['Sort'];
			}
			$order = " ORDER BY " . $order;
		}
		$sqlstr .= $order;
		if( $limit ){
			$sqlstr .= " LIMIT " . $limit;
		}
		return $this->getList($sqlstr);
    }

    /**
     * ơ֥UPDATE
     * @param $table ơ֥̾
     * @param $keyarray Update
     * @return unknown_type
     */
    function update( $table, $keyarray, $force=false ){
		if( empty($this->mData) ){
			return false;
		}
		if( empty($keyarray) ){
			return false;
		}
    	$setstr		= "";
    	foreach( $this->mData as $key => $value ){
    		if( $setstr ){
    			$setstr .= ", ";
    		}
    		$setstr .= $key . "=";

   			if( is_null($value) ){
    			$setstr .= "NULL";
   			} else if( $this->addSlashes($value) == 'NOW()' ){
    			$setstr .= $this->addSlashes($value);
    		} else {
    			$setstr .= "'" . $this->addSlashes($value) . "' ";
    		}
    	}
    	$wherestr		= "";
    	foreach( $keyarray as $key => $value ){
    		if( $wherestr ){
    			$wherestr .= " AND ";
    		}
    		$wherestr .= $key . "='" . $value . "'";
    	}
        $sqlstr = " UPDATE " . $this->mDb->prefix($table) . " SET " . $setstr . " WHERE " . $wherestr;
        return $this->execute( $sqlstr, $force );
    }

    /**
     * ơ֥INSERT
     * @param String $table ơ֥̾
     * @return boolean
     */
    function insert( $table, $force = false ) {
		if( empty($this->mData) ){
			return false;
		}
    	$keystr		= "";
    	$valuestr	= "";
    	foreach( $this->mData as $key => $value ){
    		$keystr .= "," . $key;
   			if( is_null($value) ){
    			$valuestr .= ", NULL";
   			} else if( $this->addSlashes($value) == 'NOW()' ){
    			$valuestr .= "," . $this->addSlashes($value);
   			} else {
    			$valuestr .= ",'" . $this->addSlashes($value) . "'";
    		}
    	}
    	$sqlstr =  " INSERT INTO " . $this->mDb->prefix( $table ) . " ( ";
    	$sqlstr .= substr($keystr,1) . " ) VALUES ( " . substr($valuestr,1) . " ) ";
		$rc = $this->execute( $sqlstr, $force );
		return $rc;
    }

    /**
     * ơ֥Υ쥳ɤ
     *
     * @param String $table ơ֥̾
     * @return boolean
     */
	function delete( $table ) {
		if( empty($this->mData) ){
			return false;
		}

		$wherestr = "";
		foreach( $this->mData as $key => $value ){
			if( $wherestr ){
				$wherestr .= " AND ";
			}
			$wherestr .= $key . "='" . $this->addSlashes($value) . "'";
		}
		$sqlstr = " DELETE FROM " . $this->mDb->prefix($table) . " WHERE " . $wherestr;
		return $this->execute( $sqlstr );
    }

    /**
     * ˥åȤǡΥå
     * @param String $colname DB̾
     * @param String &$data ̾б
     */
    function setData( $colname, &$data ){
		$this->mData[$colname] = $data;
    }

    /**
     * ˥åȤǡ
     */
    function unsetData() {
        unset($this->mData);
    }

    /**
     * ORDER BY ˥åȤǡΥå
     * @param String $colname DB̾
     */
    function setOrderBy( $colname, $sort = 'ASC' ){
		$this->mOrder[] = array( 'Col'=>$colname, 'Sort'=>$sort );
    }

    /**
     * ˥åȤǡ
     */
    function unsetOrderBy() {
        unset($this->mOrder);
    }
}
?>