<?php
// եࡧ塼Ͽ

if (!defined('XOOPS_ROOT_PATH')) exit();

require_once XOOPS_ROOT_PATH . "/core/XCube_ActionForm.class.php";

/***
 * ե९饹塼Ͽ
 */
class BBSB_EditSchedulememberdetailForm extends XCube_ActionForm
{
	function prepare()
	{
		// եץѥƥ
		$this->mFormProperties['sid']			=& new XCube_IntProperty('sid');				// 塼ID
		$this->mFormProperties['eid']			=& new XCube_IntProperty('eid');				// ID
		$this->mFormProperties['name']			=& new XCube_StringProperty('name');			// ̾
		$this->mFormProperties['pass']			=& new XCube_StringProperty('pass');			// ѥ
		$this->mFormProperties['comments']		=& new XCube_StringProperty('comments');		// 
		$this->mFormProperties['updatetime']	=& new XCube_StringProperty('updatetime');		// ǽ
		$this->mFormProperties['joinstateid']	=& new XCube_IntProperty('joinstateid');		// з
		$this->mFormProperties['oldjoinstateid']=& new XCube_IntProperty('oldjoinstateid');		// з()

		// եɥץѥƥ
		// 塼ID
		$this->mFieldProperties['sid']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['sid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['sid']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_SCHEDULEID, "5");
		$this->mFieldProperties['sid']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_SCHEDULEID);
		$this->mFieldProperties['sid']->addVar('maxlength', 5);
		$this->mFieldProperties['sid']->addVar('min', '1');
		$this->mFieldProperties['sid']->addVar('max', '32767');
		// ID
		$this->mFieldProperties['eid']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['eid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['eid']->addMessage('maxlength',		_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_USERID, "5");
		$this->mFieldProperties['eid']->addMessage('intRange',		_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_USERID);
		$this->mFieldProperties['eid']->addVar('maxlength', 5);
		$this->mFieldProperties['eid']->addVar('min', '1');
		$this->mFieldProperties['eid']->addVar('max', '32767');
		// ̾
		$this->mFieldProperties['name']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['name']->setDependsByArray(array('required','maxlength'));
		$this->mFieldProperties['name']->addMessage('required', 	_MD_BBSB_ERROR_REQUIRED,	_MD_BBSB_LANG_NAME);
		$this->mFieldProperties['name']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_NAME, '128');
		$this->mFieldProperties['name']->addVar('maxlength', 128);
		// ѥ
		$this->mFieldProperties['pass']			=& new XCube_FieldProperty($this);
		$this->mFieldProperties['pass']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['pass']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_PASSWORD, '32');
		$this->mFieldProperties['pass']->addVar('maxlength', 32);
		// 
		$this->mFieldProperties['comments']		=& new XCube_FieldProperty($this);
		$this->mFieldProperties['comments']->setDependsByArray(array('maxlength'));
		$this->mFieldProperties['comments']->addMessage('maxlength', _MD_BBSB_ERROR_MAXLENGTH, _MD_BBSB_LANG_COMMENT, '1024');
		$this->mFieldProperties['comments']->addVar('maxlength', 1024);
		// з
		$this->mFieldProperties['joinstateid']	=& new XCube_FieldProperty($this);
		$this->mFieldProperties['joinstateid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['joinstateid']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_JOINSTATE, "5");
		$this->mFieldProperties['joinstateid']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_JOINSTATE);
		$this->mFieldProperties['joinstateid']->addVar('maxlength', 5);
		$this->mFieldProperties['joinstateid']->addVar('min', '1');
		$this->mFieldProperties['joinstateid']->addVar('max', '32767');
		// з()
		$this->mFieldProperties['oldjoinstateid']	=& new XCube_FieldProperty($this);
		$this->mFieldProperties['oldjoinstateid']->setDependsByArray(array('maxlength','intRange'));
		$this->mFieldProperties['oldjoinstateid']->addMessage('maxlength',	_MD_BBSB_ERROR_MAXLENGTH,	_MD_BBSB_LANG_JOINSTATE, "5");
		$this->mFieldProperties['oldjoinstateid']->addMessage('intRange',	_MD_BBSB_ERROR_INTRANGE,	_MD_BBSB_LANG_JOINSTATE);
		$this->mFieldProperties['oldjoinstateid']->addVar('maxlength', 5);
		$this->mFieldProperties['oldjoinstateid']->addVar('min', '1');
		$this->mFieldProperties['oldjoinstateid']->addVar('max', '32767');
	}

	/**
	 * ̾  ϥå
	 *	ϻˡƱ̾Υ쥳ɤäϥ顼
	 */
	function validateName()
	{
		if( $this->get('eid') ){
			$exarray = array( 'EntrantID' => $this->get('eid') );	// TeamID(=)ϳ򥫥оݤˤʤ
		} else {
			$exarray = false;										// TeamIDʤ(=)
		}

		$dbSm = new BBSB_DbScheduleMember();
		$dbSm->setData( 'Name',			$this->get('name') );
		$dbSm->setData( 'ScheduleID',	$this->get('sid') );
		$count = $dbSm->CountNum( 'bb_schedulemember', $exarray );
		if( $count != 0 ){
			$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_DUPLICATE, _MD_BBSB_LANG_NAME));
		}
	}

	/**
	 * ѥ ϥå
	 *	ϻϥѥɬ
	 */
	function validatePass()
	{
		if( !$this->get('eid') ){	// EntrantID̵(=)
			if( !$this->get('pass') ){
				$this->addErrorMessage(XCube_Utils::formatMessage(_MD_BBSB_ERROR_REQUIRED, _MD_BBSB_LANG_PASSWORD));
			}
		}
	}

}
?>
